=== debian/changelog ===
cmake (2.8.3-3ubuntu7) natty; urgency=low

  * Remove unintended debhelper patch from 2.8.3-3ubuntu5

 -- Jonathan Riddell <jriddell@ubuntu.com>  Fri, 08 Apr 2011 23:33:08 +0100

cmake (2.8.3-3ubuntu6) natty; urgency=low

  * fix LP: #730365 - Check for cmake doc directory before running rmdir
    - update debian/cmake.postinst 

 -- Micah Gersten <micahg@ubuntu.com>  Sun, 20 Mar 2011 23:25:33 -0500

cmake (2.8.3-3ubuntu5) natty; urgency=low

  * Update ubuntu_multiarch_library_directory.diff:
    - Add lib/[arch triplet] to all prefix paths.
  * Add dpkg-dev to cmake Depends.

 -- Felix Geyer <debfx-pkg@fobos.de>  Sat, 19 Mar 2011 15:32:51 +0100

cmake (2.8.3-3ubuntu4) natty; urgency=low

  * Prepend multiarch directories in
    ubuntu_multiarch_library_directory.diff LP: #737137

 -- Jonathan Riddell <jriddell@ubuntu.com>  Fri, 18 Mar 2011 17:53:13 +0000

cmake (2.8.3-3ubuntu3) natty; urgency=low

  * Add ubuntu_multiarch_library_directory.diff to find location of
    multiarch directory

 -- Jonathan Riddell <jriddell@ubuntu.com>  Fri, 18 Mar 2011 17:30:30 +0000

cmake (2.8.3-3ubuntu2) natty; urgency=low

  * build-dep on libxmlrpc-core-c3-dev (>= 1.16.32-0ubuntu3), includes
    missing header file

 -- Jonathan Riddell <jriddell@ubuntu.com>  Tue, 11 Jan 2011 00:26:16 +0000

cmake (2.8.3-3ubuntu1) natty; urgency=low

  * Build-dep on libxmlrpc-core-c3-dev not libxmlrpc-c3-dev, LP: #698311

 -- Jonathan Riddell <jriddell@ubuntu.com>  Mon, 10 Jan 2011 21:19:08 +0000

cmake (2.8.3-3) experimental; urgency=low

  * Install documentation to /usr/share/cmake-data instead as it's the "base"
    package rather than cmake. Also link doc directories to it.
  * The job of replacing directories with symlinks apparently is a tough one.
    Create a symlink manually in the postinst of the affected (!cmake-data)
    packages.

 -- Modestas Vainius <modax@debian.org>  Sun, 02 Jan 2011 14:10:18 +0200

cmake (2.8.3-2) experimental; urgency=low

  [ Kai Wasserbäch ]
  * debian/source/local-options: Added "unapply-patches".
  * debian/watch: Added git-import-orig invocation.
  * debian/gbp.conf: Added, to ensure we use pristine-tar.
  * debian/patches/FindTCL_fix_#600245.diff: Added. (Closes: #600245)

  [ Modestas Vainius ]
  * Install cmake documentation into /usr/share/doc/cmake/ and link doc
    directories of the rest binary packages to it (needs debhelper 7.4.2).
    (LP: #669197)
  * Backport a patch from 2.8.4 to fix ASM support. Thanks to Leon Nardella for
    heads up. (Closes: #608510, LP: #695335)

 -- Modestas Vainius <modax@debian.org>  Sun, 02 Jan 2011 12:45:38 +0200

cmake (2.8.3-1) experimental; urgency=low

  * New upstream release.

  [ Kai Wasserbäch ]
  * debian/patches/fix_spelling_errors.patch: Added Applied-Upstream header.
  * debian/control: Bumped Standards-Version to 3.9.1, no further changes
    needed.

  [ Modestas Vainius ]
  * Drop patches which were merged upstream:
    - debian/patches/hurd_platform.diff;
    - FindGTK2_pangommconfig.diff;
    - FindJNI_fix_libarch_determination.diff;
    - cpack_installed_size.diff;
    - add_libarchive_script.patch - better version merged upstream;
    - fix-CTestTestFailedSubmit-xmlrpc.diff;
    - fix_spelling_errors.patch.
  * Adapt FindPython_fix_#569321_and_#580503.diff patch to upstream changes.
  * Bump libarchive-dev Build-Depends to 2.8.0. cmake needs symbols which
    appeared in that version. (Closes: #595275)
  * Add fixup_manpages.diff patch to fix small issues with cmake mangpages
    (found by lintian).

 -- Modestas Vainius <modax@debian.org>  Sat, 13 Nov 2010 02:16:34 +0200
