=== debian/watch ===
version=3

# Track CMake 2.6.x releases including RCs
opts="uversionmangle=s/-[Rr][Cc]-?(\d+)/~rc$1/i" \
    http://www.cmake.org/files/v([\d.]+)/ \
    cmake-([\d.]+(?i:-RC-?\d+)?).tar.gz \
    debian git-import-orig
