=== debian/changelog ===
cmake (2.8.5-1) unstable; urgency=low

  * New upstream release:
    - fixes UseSWIG. (Closes: #631497)
  * Drop screen-256color-bce.diff - merged upstream.
  * Drop spelling_formatting_fixes.diff - merged upstream.
  * Make sure CMake considers /lib/<arch> as implicit and keeps it out of
    automatic R(UN)PATH (patch multiarch_lib_dirs_should_be_implicit.diff).
  * Refresh FindBoost_add_-lpthread_#563479.diff patch.

 -- Modestas Vainius <modax@debian.org>  Sat, 09 Jul 2011 15:18:39 +0300

cmake (2.8.5~rc2-1) unstable; urgency=low

  * New upstream release.
  * No longer repack upstream tarball and drop dfsg suffix from the version
    number. The tarball is DFSG clean now.
  * Drop fixup_manpages.diff patch, merged upstream.
  * Drop backport_test_order_fix.diff patch, was backported from upstream.
  * Drop multiarch_basic_support.diff patch, merged upstream.
  * Refresh screen-256color-bce.diff patch.
  * Add spelling_formatting_fixes.diff which fixes a couple of new
    spelling / formatting errors.
  * Override incorrect menu-icon-missing lintian warning properly.

 -- Modestas Vainius <modax@debian.org>  Sun, 19 Jun 2011 17:33:45 +0300

cmake (2.8.4+dfsg.1-5) unstable; urgency=medium

  * Fix multiarch regex to support armel and (hopefully) all other possible
    linux architectures (patch multiarch_basic_support.diff updated).
  * Support multiarch paths on kfreebsd and hurd (patch
    multiarch_basic_support.diff updated). (Closes: #630167)
  * Urgency=medium, the bugs above make cmake almost unusable on armel and
    kfreebsd.

 -- Modestas Vainius <modax@debian.org>  Sat, 11 Jun 2011 22:47:18 +0300

cmake (2.8.4+dfsg.1-4) unstable; urgency=low

  * Drop multiarch_library_directory_hack.diff patch. A better solution has
    been implemented (see below).
  * Add multiarch implementation from upstream (patch
    multiarch_basic_support.diff, taken from upstream bug #12037). New
    implementation does not need dpkg-dev 1.16, it is entirely backwards
    compatible with previous releases and in addition, it implements multiarch
    support for find_package().
  * Adapt multiarch_findgtk2_fix.diff patch to work with
    multiarch_basic_support.diff.

 -- Modestas Vainius <modax@debian.org>  Thu, 09 Jun 2011 01:18:19 +0300

cmake (2.8.4+dfsg.1-3) unstable; urgency=low

  * Merge 2.8.2+dfsg.1-0+squeeze1 changes.
  * Do not start cmake description synopsis with an article.
  * Generate colour Makefiles when $TERM is set to 'screen-256color-bce'.
    Thanks to Davide Mancusi for the patch (screen-256color-bce.diff).
    (Closes: #627853)
  * Add libxmlrpc-core-c3-dev as a preferred alternative to libxmlrpc-c3-dev
    in Build-Depends. libxmlrpc-c3-dev has become a transitional package.
  * Bump Standards-Version to 3.9.2: no changes needed.
  * Switch Vcs-* debian/control fields to anonscm.debian.org.
  * Fix find_library() to find libraries in multiarch library paths (patch
    multiarch_library_directory_hack.diff). While the patch is not a good fix
    (hackish by nature, no cross-compilation support etc.), it should do the
    job in majority of cases. Also require dpkg-dev >= 1.16 at both build
    time (Build-Depends) and runtime (cmake Depends) because the patch needs
    dpkg-architecture -qDEB_HOST_MULTIARCH. (Closes: #618932)
  * Make FindGTK2.cmake work with Debian multiarch
    (patch multiarch_findgtk2_fix.diff). (LP: #751940)

 -- Modestas Vainius <modax@debian.org>  Wed, 08 Jun 2011 00:15:00 +0300

cmake (2.8.4+dfsg.1-2) unstable; urgency=low

  * Add backport_test_order_fix.diff to restore conpatibility with earlier
    versions with respect to the test run order. (Closes: #615054)

 -- Modestas Vainius <modax@debian.org>  Fri, 25 Feb 2011 19:12:33 +0200

cmake (2.8.4+dfsg.1-1) unstable; urgency=low

  * 2.8.4-2 ended up in unstable by accident :-( Fix distribution field
    accordingly.
  * Remove files licensed under proprietary licence from the original tarball.
    (Closes: #614390) Generate a new tarball with +dfsg.1 suffix. Thanks to
    Vasily Gurevich for heads up.

 -- Modestas Vainius <modax@debian.org>  Wed, 23 Feb 2011 23:12:02 +0200

cmake (2.8.4-2) unstable; urgency=low

  [ Kai Wasserbäch ]
  * debian/watch: Remove trailing backslash.

  [ Modestas Vainius ]
  * Merge 2.8.3-5.

 -- Modestas Vainius <modax@debian.org>  Sun, 20 Feb 2011 14:53:41 +0200

cmake (2.8.4-1) experimental; urgency=low

  * New upstream release.

  [ Kai Wasserbäch ]
  * Dropped obsolete patches (merged or taken from upstream):
    - backport_fix_asm_support.diff
    - FindTCL_fix_#600245.diff
    - FindPython_fix_#569321_and_#580503.diff (Please note, that upstream's
      solution is slightly different from what Debian had initially!)
  * debian/patches/FindBoost_add_-lpthread_#563479.diff: Added.
    (Closes: #563479)
  * debian/README.Debian: Deleted, we're shipping an unmodified version of the
    Python modules again.
  * debian/README.source: Deleted, not needed with "3.0 (quilt)".
  * debian/control:
    - Changed my E-Mail address.
    - Bumped B-D on debhelper.
  * debian/compat: now "8".
  * debian/rules: Updated for debhelper v8.

  [ Modestas Vainius ]
  * Disable git-import-orig in debian/watch. One extra command is not a good
    enough reason to lose control of packaging to non-trivial black-box tools.
  * Use less error-prone way of setting build flags.
  * Do not set MINGW_CC_LINUX2WIN_EXECUTABLE build flag. Workaround is no
    longer needed with ccache 3.0 or later.
  * Add verify-build-flags target to debian/rules. It can be used to verify if
    build flags are still valid (i.e. present in any of CMakeLists.txt).
  * Remove obsolete build flags from debian/rules:
    - BUILD_WXDialog;
    - TARGET_VERSION;
    - TARGET_SOVERSION;
    - BUILD_DOXYGEN.
  * Support parallel building at bootstrap phase.
  * Enable more verbosiness when bootstraping.
  * Add more spelling fixes to fixup_manpages.diff patch.


