=== debian/control ===
--- 
+++ 
@@ -1,21 +1,21 @@
 Source: cmake
 Section: devel
 Priority: optional
-Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
-XSBC-Original-Maintainer: Modestas Vainius <modax@debian.org>
-Uploaders: A. Maitland Bottoms <bottoms@debian.org>, Kai Wasserbäch <debian@carbon-project.org>
-Build-Depends: debhelper (>= 7.4.2), libcurl4-gnutls-dev, libxmlrpc-core-c3-dev (>= 1.16.32-0ubuntu3), libexpat1-dev, zlib1g-dev,
- libncurses5-dev, libqt4-dev (>= 4.4.0), procps [!hurd-any], libarchive-dev (>= 2.8.0)
-Standards-Version: 3.9.1
-Vcs-Git: git://git.debian.org/git/collab-maint/cmake.git
-Vcs-Browser: http://git.debian.org/?p=collab-maint/cmake.git;a=summary
+Maintainer: Modestas Vainius <modax@debian.org>
+Uploaders: A. Maitland Bottoms <bottoms@debian.org>, Kai Wasserbäch <curan@debian.org>
+Build-Depends: debhelper (>= 8), libcurl4-gnutls-dev, libexpat1-dev, zlib1g-dev,
+ libncurses5-dev, libqt4-dev (>= 4.4.0), procps [!hurd-any], libarchive-dev (>= 2.8.0),
+ libxmlrpc-core-c3-dev | libxmlrpc-c3-dev
+Standards-Version: 3.9.2
+Vcs-Git: git://anonscm.debian.org/git/collab-maint/cmake.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/cmake.git;a=summary
 Homepage: http://cmake.org/
 
 Package: cmake
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, cmake-data (= ${source:Version}), procps [!hurd-any], dpkg-dev (>= 1.16.0~ubuntu4)
+Depends: ${shlibs:Depends}, ${misc:Depends}, cmake-data (= ${source:Version}), procps [!hurd-any]
 Suggests: gcc, make
-Description: a cross-platform, open-source make system
+Description: cross-platform, open-source make system
  CMake is used to control the software compilation process using
  simple platform and compiler independent configuration files. CMake
  generates native makefiles and workspaces that can be used in the
